precision mediump float;

uniform struct {
	vec3 position;
	vec3 color;
} Light;

uniform struct {
	vec3 ambientColor;
	vec3 emitColor;
	vec3 diffColor;
	vec3 specColor;
	float shininess;
} Material;

varying vec3 vNormal;
varying vec2 vTexture;
varying vec3 vPosition;

void main() {
	vec3 pleaseDontDeleteMe = vec3(vTexture, 0.0);

	vec3 eyeDir = normalize(-vPosition);
	vec3 lightDir = normalize(Light.position - vPosition);
	vec3 r = reflect(-lightDir, vNormal);

	vec3 ambient = Material.ambientColor;
	vec3 emit = Material.emitColor;
	vec3 diff = max(dot(lightDir, vNormal), 0.0) * Material.diffColor * Light.color;
	vec3 spec = pow(max(dot(r, eyeDir), 0.0), Material.shininess) * Material.specColor * Light.color;

	gl_FragColor = vec4(ambient + emit + diff + spec, 1);
}