precision mediump float;

attribute vec3 vertPosition;
attribute vec3 vertNormal;
attribute vec2 vertTexture;

uniform mat4 modelViewMatrix;
uniform mat4 projectionMatrix;
uniform mat3 normalMatrix;

varying vec3 vNormal;
varying vec2 vTexture;
varying vec3 vPosition;

void main() {
	vNormal = normalize(normalMatrix * vertNormal);
	vTexture = vertTexture;
	vPosition = (modelViewMatrix * vec4(vertPosition, 1.0)).xyz;

	gl_Position = projectionMatrix * modelViewMatrix * vec4(vertPosition, 1.0);
}